/**
 **	File ......... HotButton.cpp
 **	Published ....  2004-05-15
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <SDL.h>
#include "guitypedefs.h"
#include "guicolors.h"
#include <sge.h>
//#include <iotm/Mutex.h>
#include <SDL_prim.h>

#include "TTFont.h"
#include "SDLControl.h"
#include "Surface.h"
#include "Static.h"
#include "Button.h"
#include "HotButton.h"


namespace gui
{


HotButton::HotButton(Surface *s,coord_t x,coord_t y,buttonstyle_t style,SurfaceHelper *sh)
:Button(s,x,y,style,sh)
{
	SetClickable(true);
}


HotButton::~HotButton()
{
}


void HotButton::OnMouseIn()
{
	Surface *pclParent = GetParent();
	if (IsClickable())
	{
		SetInverted(true);
		while (pclParent)
		{
			if (pclParent -> UseTemporaryScreen())
			{
				pclParent -> DrawTemporaryScreen();
				break;
			}
			pclParent = pclParent -> GetParent();
		}
		InvalidateEv();
	}
}


void HotButton::OnMouseOut()
{
	Surface *pclParent = GetParent();
	if (IsClickable())
	{
		SetInverted(false);
		while (pclParent)
		{
			if (pclParent -> UseTemporaryScreen())
			{
				pclParent -> DrawTemporaryScreen();
				break;
			}
			pclParent = pclParent -> GetParent();
		}
		InvalidateEv();
	}
}


void HotButton::OnClick(coord_t x,coord_t y)
{
//	printf("HotButton::OnClick()\n");
	OnButton();
	SetTimer(250);
}


void HotButton::OnTimer(long id)
{
//printf("HotButton::OnTimer()\n");
	if (IsInverted())
	{
		OnButton();
		SetTimer(90);
	}
}


} // namespace gui


