/**
 **	File ......... Menu.cpp
 **	Published ....  2004-05-15
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <SDL.h>
#include "guitypedefs.h"
#include "guicolors.h"
#include <sge.h>

#include "TTFont.h"
#include "Surface.h"
#include "Hotspot.h"
#include "MenuItem.h"
#include "Menu.h"


namespace gui
{


Menu::Menu(Surface *s,SurfaceHelper *pclHelper)
:Surface(s,pclHelper)
,m_w(0)
,m_h(0)
,m_pclSubMenu(NULL)
{
	SetFrameWidth(DIALOG_DEFAULT_FW);
}


Menu::~Menu()
{
}


void Menu::AddMenuItem(MenuItem *pclItem)
{
	m_w = pclItem -> GetW() > m_w ? pclItem -> GetW() : m_w;
	pclItem -> SetY(m_h);
	m_h += pclItem -> GetH();

//	m_items.insert(m_items.end(), pclItem);
	AddChild(pclItem);
}


void Menu::CreateMenu()
{
	surfacevector_t::iterator it;
	int fw = GetFrameWidth();

	for (it = m_ChildList.begin(); it != m_ChildList.end(); it++)
	{
		MenuItem *pclItem = static_cast<MenuItem *>(*it);
		pclItem -> SetW(m_w);
		pclItem -> CreateMenuItem();
	}

	SetW(m_w + fw * 2);
	SetH(m_h + fw * 2);

	RecreateSurfaces();

//	SetBgColor(192,192,192);
//	SetFgColor(128,255,255);
	SetBgColor(DIALOG_DEFAULT_BG_R,DIALOG_DEFAULT_BG_G,DIALOG_DEFAULT_BG_B);
	SetFrameColor(DIALOG_DEFAULT_FC_R,DIALOG_DEFAULT_FC_G,DIALOG_DEFAULT_FC_B);
}


void Menu::Draw()
{
	SDL_Rect *area = GetClientRectPtr();
	Uint32 color = GetBgColor();

	SDL_FillRect(m_screen, area, color);
}


void Menu::OnRightClick(coord_t x,coord_t y)
{
	Surface *head = this;
	
	while (head -> GetBond())
	{
		head = head -> GetBond();
	}
	head -> CloseAll();
	head -> RemoveAllBonds();
}


void Menu::ActivateSubMenu(Menu *pclMenu,coord_t x,coord_t y)
{
	if (m_pclSubMenu && m_pclSubMenu -> IsVisible())
	{
		SDL_Rect a = m_pclSubMenu -> GetAbsoluteRect();
		InvalidateRectEv(a);
		m_pclSubMenu -> SetVisible(false);
		Unbond(m_pclSubMenu);
	}
	m_pclSubMenu = pclMenu;
	m_pclSubMenu -> SetX(x);
	m_pclSubMenu -> SetY(y);
	GetParent() -> CalculateAbsolute();
	m_pclSubMenu -> SetVisible(true);
	m_pclSubMenu -> SetDirty(true);
	m_pclSubMenu -> InvalidateEv();
	Bond(m_pclSubMenu);
}


Menu *Menu::GetSubMenu(int id)
{
	return NULL;
}


} // namespace
