/**
 **	File ......... Progress.cpp
 **	Published ....  2004-05-15
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <SDL.h>
#include "guitypedefs.h"
#include "guicolors.h"
#include <sge.h>
//#include <iotm/Mutex.h>

#include "TTFont.h"
#include "SDLControl.h"
#include "Surface.h"
#include "Progress.h"


namespace gui
{


Progress::Progress(Surface *s,coord_t x,coord_t y,coord_t w,coord_t h,SurfaceHelper *sh)
:Surface(s,x,y,w,h,sh)
,m_max(100)
,m_pos(0)
{
	SetFrameColor(0,0,0);
	SetFrameWidth(1);
}


Progress::~Progress()
{
}


void Progress::SetMax(long x)
{
	m_max = x;
}


void Progress::SetPos(long x)
{
	m_pos = x;
	SetDirty(true);
}


void Progress::Draw(void)
{
	SDL_Rect r = GetClientRect();
	SDL_Rect a = r;
	long w = (m_pos * (long)GetW()) / m_max;

	SDL_FillRect(m_screen, &r, GetBgColor());

	a.w = w;
	if (a.w)
	{
	// copy bmp?
		SDL_FillRect(m_screen, &a, GetFgColor());
	}
	a.x = r.x + w; // ClientRect.x kan vara > 0 (FrameWidth)
	a.w = r.w - w;
	if (a.w)
	{
		SDL_FillRect(m_screen, &a, GetBgColor());
	}
}


void Progress::SetMax()
{
	m_pos = m_max;
	SetDirty(true);
}


} // namespace gui


