/**
 **	File ......... Xml.cpp
 **	Published ....  2004-05-15
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdio.h>
#include <SDL.h>
#ifdef WIN32
#define STL_USING_ALL
#include <include/stlhelper.h>
#else
#include <string>
#endif

#include "Xml.h"


namespace util
{


Xml::Xml(FILE *f)
:m_fil(f)
{
}


Xml::~Xml()
{
}


void Xml::Write(const char *s,bool b)
{
	fprintf(m_fil,"<%s>%s</%s>\n",s,b ? "true" : "false",s);
}


void Xml::Write(const char *s,char c)
{
	fprintf(m_fil,"<%s>%c</%s>\n",s,c,s);
}


void Xml::Write(const char *s,long l)
{
	fprintf(m_fil,"<%s>%ld</%s>\n",s,l,s);
}


void Xml::Write(const char *s,SDL_Color &color)
{
	fprintf(m_fil,"<%s>\n",s);
	fprintf(m_fil,"<R>%d</R>\n",color.r);
	fprintf(m_fil,"<G>%d</G>\n",color.g);
	fprintf(m_fil,"<B>%d</B>\n",color.b);
	fprintf(m_fil,"<A>%d</A>\n",color.unused);
	fprintf(m_fil,"</%s>\n",s);
}


void Xml::Write(const char *s,std::string &str)
{
	fprintf(m_fil,"<%s>%s</%s>\n",s,str.c_str(),s);
}


} // namespace util


