/**
 **	File ......... guitypedefs.h
 **	Published ....  2004-05-15
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _GUITYPEDEF_H
#define _GUITYPEDEF_H

#ifdef WIN32
#define STL_USING_ALL
#include <stlhelper.h>
#else
#include <vector>
#include <string>
#include <map>
#endif


#ifndef DEB
#ifdef _DEBUG
#define DEB(x) x
#else
#define DEB(x)
#endif
#endif


// ScrollBar width/height
#define SBSIZE 16

// -- begin
#define SDL_USEREVENT_PAINT          1000
#define SDL_USEREVENT_INVALIDATE     1001
#define SDL_USEREVENT_INVALIDATERECT 1002
#define SDL_USEREVENT_LOSTFOCUS      1003
#define SDL_USEREVENT_FILLRECT       1004
#define SDL_USEREVENT_RESETFILLRECTS 1005
#define SDL_USEREVENT_UICOMMAND      1006
#define SDL_USEREVENT_TIMER          1007
// -- end
#define UICOMMAND_NONE      -1
//
#define GUI_EVENT_MOUSEIN    1
#define GUI_EVENT_MOUSEOUT   2
#define GUI_EVENT_BUTTON     3
#define GUI_EVENT_CLOSE      4
#define GUI_EVENT_EDIT       5 // return pressed in edit field
// --


using std::string;

namespace gui
{
typedef Uint32 color_t;
typedef short coord_t;
typedef unsigned char alpha_t;
typedef short style_t;
typedef std::vector<class Surface *> surfacevector_t;
typedef std::vector<std::string> stringvector_t;
typedef std::vector<SDL_Rect> rectvector_t;
// a surface_event_t struct is sent to parent when child generates an event
typedef struct surface_event_struct
{
	Uint8 type; // GUI_EVENT_xx
	unsigned long id;
	unsigned long local_id;
	Surface *ptr;
} surface_event_t;

}


#endif // _GUITYPEDEF_H
